/*

    *********************************
    *   Make a fBm out of a noise   *
    *********************************

    Copyright (C) 2003 Samuel Nicolay.
    email: <S.Nicolay@ulg.ac.be>


    This program is a free software, you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (in a file named COPYRIGHT);
    if not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
To compile, type something like 
gcc fbm2noise.c utils.c -o fbm2noise
*/

#include<stdio.h>
#include<stdlib.h>
#include"utils.h"  /*Some useful easy functions*/

void chol_dec(float **output, long int size,float h,float var);
void help(char *file_name);
int main(int arg_c,char **arg_v){
  int j,no_name1=0,no_name2=0;
  float sum,noise;
  char *name1,*name2;
  FILE *input_file,*output_file;

/*
************************************
*   First, we get the parameters   *
************************************
*/

  for (j=1;j<arg_c;j++) 
    if (arg_v[j][0]=='-')
      if (w1_is_w2("help",arg_v[j]+1,'-')){help(arg_v[0]);exit(0);}

  if (arg_c<2) {
    name1 = (char*) malloc(10*sizeof(char));
    name1[0]='n';name1[1]='o';name1[2]='i';name1[3]='s';name1[4]='e';name1[5]='.';name1[6]='d';name1[7]='a';name1[8]='t';name1[9]='\0';
    no_name1=1;
    fprintf(stderr,"Input filename not specified.\nThe default name is \"%s\".\n",name1);
  }
  else name1=arg_v[1];

  if (arg_c<3) {
    name2 = (char*) malloc(8*sizeof(char));
    name2[0]='f';name2[1]='b';name2[2]='m';name2[3]='.';name2[4]='d';name2[5]='a';name2[6]='t';name2[7]='\0';
    no_name2=1;
    fprintf(stderr,"Output filename not specified.\nThe default name is \"%s\".\n",name2);
  }
  else name2=arg_v[2];



/*
*********************************************************
*   Open the files, read the noise and write the fBm    *
*********************************************************
*/

  if ((input_file=fopen(name1,"r"))==NULL) fprintf(stderr,"Could not open \"%s\" for reading.\n",name1);
  if ((output_file=fopen(name2,"w"))==NULL) fprintf(stderr,"Could not open \"%s\" for writing.\n",name2);
  sum=0;
  while(!feof(input_file)){
    fscanf(input_file,"%f\n",&noise);
    sum += noise;
    fprintf(output_file,"%f\n",sum);
  }

  fclose(input_file);
  fclose(output_file);

  if (no_name1) free(name1);
  if (no_name2) free(name2);
  return 0;
}

void help(char *file_name){
/*
*********************
*   Give the help   *
*********************
*/
  printf("%s [input_filename] [output_filename]\n",file_name);
  printf("Give the fBm of a noise given by \"input_filename\".\n");
  printf("The output will be saved in the file \"output_filename\".\n");
}
