/*

    ****************************
    *   Some basic functions   *
    ****************************

    Copyright (C) 2003 Samuel Nicolay.
    email: <S.Nicolay@ulg.ac.be>


    This program is a free software, you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (in a file named COPYRIGHT);
    if not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include<stdio.h>
#include<stdlib.h>
#include<time.h>

void error(char error_text[]){
  fprintf(stderr,"Run-Time error.\n");
  fprintf(stderr,"%s\n",error_text);
  exit(1);
}

long int biggest2pow(long int num){
  long int pow;

  pow=1;
  while(pow<num) pow <<= 1;
  return pow;

}

int w1_is_w2(char *word1,char *word2,char delimit){
  int j,k;

  j=0;
  if (delimit!='\0') while(word2[j]==delimit)j++;

  k=0;
  while(word2[j+k]==word1[k])k++;

  j=0;
  if (k>0)
    if (word1[k-1]=='\0') j=1;

  return j;
}

int string_is_float(char *string){
  int j,flag;

  j=0;flag=0;
  while (string[j]!='\0'){
    if (string[j]=='.') flag++;
    else if (string[j]<'0' || string[j]>'9')flag=2;
    j++;
  }
  if (flag>=2) flag=0;
  else flag=1;

  return flag;
}

int string_is_int(char *string){
  int j,flag;

  j=0;flag=0;
  while (string[j]!='\0'){
    if (string[j]<'0' || string[j]>'9')flag=2;
    j++;
  }
  if (flag>=2) flag=0;
  else flag=1;

  return flag;
}

double string2float(char *string){
  double converted,divider;
  int j=1,not_real=0;

  if (string[0]=='.') {j=0;converted=0;}
  else if (string[0]!='\0') converted=string[0]-48;

  while (string[j]!='\0'){
    if (string[j]=='.') {
      not_real=1;
      divider=10;
    }
    else {
      if (not_real){
	converted += (string[j]-48)/divider;
	divider *= 10;
      }
      else{
	converted *= 10;
	converted += string[j]-48;
      }
    }
    j++;
  }

  return converted;
}

float time_spent(void){
  return ((float) clock()/CLOCKS_PER_SEC);
}
